
#    LUCI is an Universal Configuration Interface
#    Copyright (C) 1999-2001 Jrme SAUTRET <Jerome.Sautret@netcourrier.com>
#                                                                
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or   
#    (at your option) any later version.                              
#                                      
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of 
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
#    GNU General Public License for more details.                 
#                                               
#    You should have received a copy of the GNU General Public License
#    along with this program; see the file COPYING.  If not, write to 
#    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
#    Boston, MA 02111-1307, USA.


import types
import imp

def get_module(desc_file):
	"return a module for the description file"
	
	try:
		#module=imp.new_module('desc_file')
		f=open(desc_file,'r')
		module=imp.load_source(desc_file,desc_file,f)
		f.close()
		return module
	except IOError:
		print "Error, Can't find description file '"+desc_file+"'."
		raise SystemExit, 4
	except SyntaxError, m:
		print "Error in description file '"+desc_file+"',"
		print m.msg+" on line", m.lineno,":"
		print m.text, (" "*(m.offset-1))+"^"
		raise SystemExit, 5
	except NameError, m :
		print "Error in description file '"+desc_file+"',"
		print m,"is unknown."
		raise SystemExit, 5
	    
	    
def get_entries(module):
	"return a dictionnary of all the entries in the desc file indexed"
	"by their names"
	entries={}
	params={}
	for i in dir(module):
		symbol=getattr(module,i)
		if i[0]!='_':
		    if type(symbol)==types.DictType:
			entries[i]=(symbol)  # desc of an entry
			entries[i]['_active']=0
			entries[i]['_entry_name']=i
		    else:
			params[i]=symbol   # global param
	return params, entries

