#!/usr/bin/env python

#    installer fo LUCI
#    Copyright (C) 1999-2001 Jrme SAUTRET <Jerome.Sautret@netcourrier.com>
#                                                                
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or   
#    (at your option) any later version.                              
#                                      
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of 
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
#    GNU General Public License for more details.                 
#                                               
#    You should have received a copy of the GNU General Public License
#    along with this program; see the file COPYING.  If not, write to 
#    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
#    Boston, MA 02111-1307, USA.


import string, os, shutil, stat, compileall
import sys

default_prefix="/usr/local"
descdir='/etc/luci'
programs=['luci', 'create_desc_file']
modules=['desc','gui', 'gui_entries', 'gui_tree', 'file']

PREFIX = DESTDIR = ''
for arg in sys.argv[1:]:
    var,val = string.split(string.strip(arg), '=')
    if   var == 'PREFIX':  PREFIX  = val
    elif var == 'DESTDIR': DESTDIR = val

if PREFIX:
    prefix = PREFIX
else:
    print """
This program will install LUCI on your system.

Choose a prefix for the location installation. LUCI modules will
be installed in PREFIX/lib/luci and the LUCI executable will be
copied in PREFIX/bin. Just press enter to accept""", default_prefix, """ as
a default prefix.
"""
    prefix=raw_input("Enter a prefix ["+default_prefix+"]:")

if string.strip(prefix)=="":
    prefix=default_prefix
else:
    prefix=os.path.abspath(prefix)

if DESTDIR:
    destdir = DESTDIR
else:
    destdir = prefix

moduledir=destdir+"/lib/luci"
bindir=destdir+"/bin"

if not os.path.isdir(bindir):
    os.makedirs(bindir)
if not os.path.isdir(moduledir):
    os.makedirs(moduledir)

moduledir=moduledir+"/"
bindir=bindir+"/"

moduleinst=prefix+"/lib/luci/"

for program in programs:
    print "Installing "+program+" in "+bindir+" ..."
    try:
        fin=open(program, "r")
    except IOError:
        print "Can't open "+program+" file for reading, aborting."
        raise SystemExit, 1
    try:
        fout=open(bindir+program, "w")
    except IOError:
        print "Can't create "+bindir+program+", aborting."
        raise SystemExit, 2

    for line in fin.readlines():
        fout.write(string.replace(line,
                                  "luci_module_path='/usr/local/lib/luci'",
                                  "luci_module_path='"+moduleinst+"'"))

    fin.close()
    fout.close()

    # set executable
    os.chmod(bindir+program, stat.S_IMODE(os.stat(bindir+program)[0]) | 0111)

print "Installing modules in "+moduledir+" ..."
for module in modules:
    module=module+'.py'
    shutil.copyfile(module, moduledir+module)

compileall.compile_dir(moduledir)

def my_copytree(src, dest):
    for f in os.listdir(src):
        pathsrc='%s/%s' % (src, f)
        pathdest='%s/%s' % (dest, f)
        if os.path.isdir(pathsrc):
            if not os.path.isdir(pathdest):
                os.mkdir(pathdest)
            my_copytree(pathsrc, pathdest)
        else:
            shutil.copyfile(pathsrc, pathdest)
        

print "Installing description files in "+descdir+" ..."
try:
    if not os.path.isdir(descdir):
        os.makedirs(descdir)
    my_copytree('examples', descdir)
except IOError:
    print "Cannot write desc files in "+descdir
except OSError:
    print "Cannot create "+descdir+" directory"

    
uninstall= """
LUCI is now installed.
To uninstall, type:
rm """ + bindir + "{"
for program in programs[:-1]:
    uninstall = uninstall + program+","
uninstall = uninstall + programs[-1]+"} && rm -rf " + moduledir + "\n"
print uninstall
